package
{
    import flash.display.*;
    import flash.events.*;

    public class Slider extends Sprite
    {
        private var buttonDown:Boolean = false;
        private var minimum:Number;
        private var maximum:Number;
        private var knob:Sprite = new Sprite();
        private var value:Number;

        public function Slider(min:Number, max:Number, v:Number, w:Number, h:Number)
        {
            value = v;
            minimum = min;
            maximum = max;

            graphics.beginFill(0xffffff);
            graphics.drawRect(0, 0, w, h);
            graphics.beginFill(0xff000000);
            graphics.drawRect((w - 5)/2, 5, 5, h - 10);

            width = w;
            height = h;

            knob.graphics.beginFill(0);
            knob.graphics.drawRoundRect(-10, -7, 20, 14, 6, 4);
            setValue(value);
            knob.x = w/2;
            addChild(knob);
        }

        public function mouseDown(event:MouseEvent):void
        {
            if (event.stageX < x || event.stageX >= x + width || event.stageY < y || event.stageY >= y + height)
                return;
            buttonDown = true;
        }

        public function mouseUp(event:MouseEvent):void
        {
            buttonDown = false;
        }

        public function mouseMove(event:MouseEvent):void
        {
            if (!buttonDown)
                return;
            if (event.stageY >= 5 && event.stageY <= height - 5) {
                knob.y = event.stageY - y;
                value = (knob.y - 5)*(maximum - minimum)/(height - 10) + minimum;
            }
        }

        public function getValue():Number
        {
            return value;
        }

        public function setValue(v:Number):void
        {
            if (v < minimum)
                v = minimum;
            if (v > maximum)
                v = maximum;
            value = v;
            knob.y = 5 + (value - minimum)*(height - 10)/(maximum - minimum);
        }
    }
}
