package
{
    import flash.display.*;
    import flash.events.*;
    import flash.ui.*;

    [SWF(width = "400", height = "240", frameRate = "60", backgroundColor = "#000000")]
    public class wavet extends Sprite
    {
        private var xp:Number = 160;
        private var yp:Number = 120;
        private var xv:Number = 0;
        private var yv:Number = 0;
        private var data:BitmapData = new BitmapData(320, 240);
        private var xm:Number = 160;
        private var ym:Number = 120;
        private var buttonDown:Boolean = false;
        private var tension:Slider = new Slider(-16, 0, -5, 40, 240);
        private var friction:Slider = new Slider(0, 1/4, 0, 40, 240);

        private var ox:Array = new Array();
        private var oy:Array = new Array();
        private var xx:Array = new Array();
        private var yy:Array = new Array();
        private var vx:Array = new Array();
        private var vy:Array = new Array();

        public function wavet()
        {
            tension.x = 320;
            tension.y = 0;
            addChild(tension);

            friction.x = 360;
            friction.y = 0;
            addChild(friction);

            stage.addEventListener(MouseEvent.MOUSE_DOWN, mouseDown);
            stage.addEventListener(MouseEvent.MOUSE_UP, mouseUp);
            stage.addEventListener(MouseEvent.MOUSE_MOVE, mouseMove);
            stage.addEventListener(KeyboardEvent.KEY_DOWN, keyDown);
            addEventListener(Event.ENTER_FRAME, update);

            for (var i:int = 0; i < 33; ++i) {
               xx[i] = 160;
               yy[i] = 120;
               vx[i] = 0;
               vy[i] = 0;
               ox[i] = xx[i];
               oy[i] = yy[i];
            }
        }

        private function update(event:Event):void
        {
            graphics.clear();
            graphics.moveTo(xx[0], yy[0]);
            graphics.lineStyle(1, 0xffffff);
            var i:int;
            for (i = 1; i <= 32; ++i)
                graphics.lineTo(xx[i], yy[i]);

            for (i = 1; i < 32; ++i) {
                vx[i] += (Math.pow(2, tension.getValue())*((ox[i-1] + ox[i+1])/2 - xx[i]) - friction.getValue()*vx[i]);
                vy[i] += (Math.pow(2, tension.getValue())*((oy[i-1] + oy[i+1])/2 - yy[i]) - friction.getValue()*vy[i]);
                xx[i] += vx[i];
                yy[i] += vy[i];
            }

            for (i = 0; i <= 32; ++i) {
                ox[i] = xx[i];
                oy[i] = yy[i];
            }

            graphics.lineTo(xp, yp);
        }

        private function mouseDown(event:MouseEvent):void
        {
            tension.mouseDown(event);
            friction.mouseDown(event);
            if (event.stageX < 0 || event.stageX >= 320 || event.stageY < 0 || event.stageY >= 240)
                return;
            buttonDown = true;
            mouseMove(event);
        }

        private function mouseUp(event:MouseEvent):void
        {
            buttonDown = false;
            tension.mouseUp(event);
            friction.mouseUp(event);
        }

        private function mouseMove(event:MouseEvent):void
        {
            tension.mouseMove(event);
            friction.mouseMove(event);
            if (!buttonDown)
                return;
            xx[0] = event.stageX;
            yy[0] = event.stageY;
            ox[0] = x[0];
            oy[0] = y[0];
        }

        private function keyDown(event:KeyboardEvent):void
        {
            var s:String = String.fromCharCode(event.charCode);
            if (event.keyCode == 187 /*Keyboard.EQUAL*/)
                tension.setValue(tension.getValue() + 1);
            if (event.keyCode == 189 /*Keyboard.MINUS*/)
                tension.setValue(tension.getValue() - 1);
            if (event.keyCode == 188 /*Keyboard.COMMA*/)
                friction.setValue(friction.getValue() - 1/1024);
            if (event.keyCode == 190 /*Keyboard.PERIOD*/)
                friction.setValue(friction.getValue() + 1/1024);
            if (event.keyCode == Keyboard.ESCAPE)
                for (var i:int = 0; i < 33; ++i) {
                   xx[i] = 160;
                   yy[i] = 120;
                   vx[i] = 0;
                   vy[i] = 0;
                   ox[i] = x[i];
                   oy[i] = y[i];
                }
        }
    }
}
